<script setup lang="ts">
import { onBeforeMount, reactive } from "vue";
import { useRoute, useRouter } from "vue-router";
import { useNameStore, useUserStore } from "@/stores";
import type { ApiTokenOut, UserOut } from "@/client";
import SearchUserModal from "@/components/modals/SearchUserModal.vue";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import dayjs from "dayjs";
import DeleteApiTokenModal from "@/components/user/DeleteApiTokenModal.vue";

const route = useRoute<"admin-tokens">();
const router = useRouter();

const userRepository = useUserStore();
const nameRepository = useNameStore();

const QUERY_PARAM_OWNER_ID = "owner_id";

const filters = reactive<{
  ownerId: string;
}>({
  ownerId: "",
});

const formState = reactive<{
  searched: boolean;
  loading: boolean;
  tokens: ApiTokenOut[];
  deleteToken?: ApiTokenOut;
}>({
  searched: false,
  loading: false,
  tokens: [],
  deleteToken: undefined,
});

function searchTokens() {
  formState.loading = true;
  userRepository
    .fetchApiTokens(filters.ownerId ? filters.ownerId : undefined)
    .then((tokens) => {
      formState.tokens = tokens;
      userRepository.fetchUsernames(tokens.map((token) => token.uid));
    })
    .finally(() => {
      formState.searched = true;
      formState.loading = false;
    });
  const queryParams: Record<string, string> = {};
  if (filters.ownerId.length > 0) {
    queryParams[QUERY_PARAM_OWNER_ID] = filters.ownerId;
  }
  router.replace({
    name: "admin-tokens",
    query: queryParams,
  });
}

function resetForm() {
  filters.ownerId = "";
  formState.tokens = [];
  formState.searched = false;
  router.replace({ name: "admin-tokens" });
}

function updateUser(user: UserOut) {
  filters.ownerId = user.uid;
}

function confirmedDeleteApiToken(tokenId: string) {
  formState.loading = true;
  formState.deleteToken = undefined;
  userRepository
    .deleteApiToken(tokenId)
    .then(() => {
      formState.tokens = formState.tokens.filter(
        (token) => token.token_id !== tokenId,
      );
    })
    .finally(() => {
      formState.loading = false;
    });
}

onBeforeMount(() => {
  let search = false;
  if (route.query[QUERY_PARAM_OWNER_ID] != undefined) {
    if (typeof route.query[QUERY_PARAM_OWNER_ID] === "string") {
      filters.ownerId = route.query[QUERY_PARAM_OWNER_ID];
      userRepository.fetchUsernames([route.query[QUERY_PARAM_OWNER_ID]]);
      search = true;
    }
  }
  if (search) {
    searchTokens();
  }
});
</script>

<template>
  <search-user-modal
    modal-id="admin-token-search-user-modal"
    @user-found="updateUser"
  />
  <delete-api-token-modal
    modal-id="admin-delete-api-token-modal"
    :token="formState.deleteToken"
    @confirm-delete="confirmedDeleteApiToken"
  />
  <div class="border-bottom mb-4">
    <h2>Manage API tokens</h2>
  </div>
  <form
    id="admin-tokens-search-form"
    @submit.prevent="searchTokens"
    @reset.prevent="resetForm"
  >
    <div class="mb-2">
      <label for="admin-tokens-user-search" class="form-label"
        >Name of the owner</label
      >
      <div class="input-group">
        <div class="input-group-text">
          <font-awesome-icon icon="fa-solid fa-user" />
        </div>
        <input
          id="admin-token-user-search"
          type="text"
          class="form-control"
          readonly
          :value="nameRepository.getName(filters.ownerId)"
          placeholder="Search for owner"
          data-bs-toggle="modal"
          data-bs-target="#admin-token-search-user-modal"
        />
      </div>
    </div>
    <button
      type="submit"
      class="btn btn-primary w-fit"
      :disabled="formState.loading"
    >
      Search
    </button>
    <button
      type="reset"
      class="btn-primary btn w-fit ms-4"
      :disabled="formState.loading"
    >
      Reset
    </button>
  </form>
  <div class="overflow-x-auto" style="max-width: 100vw">
    <table class="table table-striped align-middle">
      <thead>
        <tr>
          <th scope="col"><b>Name</b></th>
          <th scope="col">ID</th>
          <th scope="col">Owner</th>
          <th scope="col">Created at</th>
          <th scope="col">Last used</th>
          <th scope="col">Expires at</th>
          <th scope="col">Scope READ</th>
          <th scope="col">Scope WRITE</th>
          <th></th>
        </tr>
      </thead>
      <tbody v-if="formState.tokens.length === 0">
        <tr>
          <td colspan="9" class="text-center fst-italic fw-light">
            <template v-if="formState.searched"
              >No API tokens found with specified filters
            </template>
            <template v-else
              >Select a filter and search for API tokens
            </template>
          </td>
        </tr>
      </tbody>
      <tbody v-else>
        <tr v-for="token in formState.tokens" :key="token.token_id">
          <th scope="row">{{ token.name }}</th>
          <td>{{ token.token_id }}</td>
          <td>{{ nameRepository.getName(token.uid) }}</td>
          <td>
            {{ dayjs.unix(token.created_at).format("MMM DD, YYYY HH:mm:ss") }}
          </td>
          <td>
            <span v-if="token.last_used">{{
              dayjs.unix(token.last_used).format("MMM DD, YYYY HH:mm:ss")
            }}</span
            ><span v-else class="fa-italic">Never</span>
          </td>
          <td>
            <span v-if="token.expires_at">{{
              dayjs.unix(token.expires_at).format("MMM DD, YYYY")
            }}</span
            ><span v-else class="fa-italic">Never</span>
          </td>
          <td class="text-center">
            <input
              type="checkbox"
              class="form-check-input"
              :checked="token.scopes.includes('read')"
              disabled
            />
          </td>
          <td class="text-center">
            <input
              type="checkbox"
              class="form-check-input"
              :checked="token.scopes.includes('write')"
              disabled
            />
          </td>
          <td>
            <button
              type="button"
              class="btn btn-danger"
              data-bs-toggle="modal"
              data-bs-target="#admin-delete-api-token-modal"
              @click="formState.deleteToken = token"
            >
              Delete
            </button>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<style scoped></style>
